import { ValidatorOptions, ValidatePatternRules, ValidateRules, ValidateFormatsMap, ValidateRulesMap, ValidateResponse, ValidateDescription, ValidateFieldOptions, ValidateCalculator, ValidateNodeResult } from './types';
import { FormPath, FormPathPattern } from '@formily/shared';
declare class FormValidator {
    private validateFirst;
    private nodes;
    private matchStrategy;
    constructor(options?: ValidatorOptions);
    transformRules(rules: ValidatePatternRules): any;
    internalValidate(value: any, rules: ValidateRules, options?: ValidateFieldOptions): Promise<{
        errors: string[];
        warnings: string[];
    }>;
    validateNodes(pattern: FormPath, options: ValidateFieldOptions): Promise<ValidateNodeResult>;
    validate: (path?: FormPathPattern, options?: ValidateFieldOptions) => Promise<ValidateNodeResult>;
    register: (path: FormPathPattern, calculator: ValidateCalculator) => void;
    unregister: (path: FormPathPattern) => void;
    static template: (message: ValidateResponse, data: ValidateDescription & {
        value: any;
        key: string;
    }) => string;
    static registerRules(rules: ValidateRulesMap): void;
    static registerFormats(formats: ValidateFormatsMap): void;
    static registerMTEngine: (template: any) => void;
}
export { FormValidator };
